<?php
/*
$Id: autorisation.class.php,v 1.9 2008-08-28 15:38:20 fraynaud Exp $
*/
require_once ($path_om."formulairedyn.class.php");
require_once ($path_om."dbformdyn.class.php");

class autorisation extends dbForm {

    var $table="autorisation";
    var $clePrimaire= "autorisation";
    var $typeCle= "N" ;


function setvalF($val){
$this->valF['autorisation'] = $val['autorisation'];
$this->valF['emplacement'] = $val['emplacement'];
$this->valF['nature'] = $val['nature'];
$this->valF['titre'] = $val['titre'];
$this->valF['nom'] = $val['nom'];
$this->valF['prenom'] = $val['prenom'];
$this->valF['marital'] = $val['marital'];
if($val['datenaissance']!="")
    $this->valF['datenaissance'] = $this->dateDB($val['datenaissance']);
$this->valF['adresse1'] = $val['adresse1'];
$this->valF['adresse2'] = $val['adresse2'];
$this->valF['cp'] = $val['cp'];
$this->valF['ville'] = $val['ville'];
$this->valF['telephone'] = $val['telephone'];
$this->valF['dcd'] = $val['dcd'];
$this->valF['observation'] = $val['observation'];
}

function setValFAjout($val){
}

function setId($db){
$this->valF['autorisation'] = $db->nextId($this->table);
}

function verifierAjout(){
}

function verifier(){
$this->correct=True;
$f="&nbsp!&nbsp;&nbsp;&nbsp;&nbsp;";
$imgv="<img src='../img/punaise.png' style='vertical-align:middle' hspace='2' border='0'>";
if ($this->valF['nom']==""){
   $this->correct=false;
     $this->msg= $this->msg.$imgv.$this->lang("nom")."&nbsp;".
     $this->lang("obligatoire").$f;
}
if ($this->valF['prenom']==""){
   $this->correct=false;
     $this->msg= $this->msg.$imgv.$this->lang("prenom")."&nbsp;".
     $this->lang("obligatoire").$f;
}
}

//form
function retour($premier,$recherche){
if (!$this->correct){
     echo "<a href=\"tab.php?obj=".$this->nature.
     "&premier=".$premier."&recherche=".$recherche.
     "\">";
     echo"<img src='../img/retour.png' align='top' hspace='10' border='0'>";
     echo "</a></center></td> </tr>";
}else{
     echo "<tr><td><br></td></tr><tr><td colspan=2><center><a href=\"tab.php?obj=".$this->nature.
     "&premier=".$premier."&recherche=".$recherche.
     "\">";
     echo"<img src='../img/retour.png' align='top'  border='0'>";
     echo "</a></center></td> </tr>";
}}

function setType(&$form,$maj) {
if ($maj < 2) { //ajouter et modifier  [add and modify]
  $form->setType('titre', 'select');
  $form->setType('nature', 'hiddenstatic');
  $form->setType('datenaissance', 'date2');
  $form->setType('emplacement', 'hiddenstatic');
  $form->setType('dcd', 'select');
  $form->setType('observation', 'textarea');
  $form->setType('parente', 'hidden');
  if($maj==0)
      $form->setType('autorisation', 'hidden');
  else
      $form->setType('autorisation', 'hiddenstatic');
}else{ // supprimer  [delete]
     $form->setType('autorisation', 'hiddenstatic');
     $form->setType('emplacement', 'hiddenstatic');
}}

// emplacement
function setValsousformulaire(&$form,$maj,$validation,$idxformulaire,$retourformulaire,$typeformulaire){
if ($validation==0) {
  if ($maj == 0){
    $form->setVal('emplacement', $idxformulaire);
    $form->setVal('nature', $this->nature);
}}
}


function setTaille(&$form,$maj){
$form->setTaille('observation', 70);
$form->setTaille('cp', 10);
$form->setTaille('telephone', 15);
$form->setTaille('datenaissance', 12);
}

function setMax(&$form,$maj){
$form->setMax('nom',40 );
$form->setMax('marital',40 );
$form->setMax('prenom',40 );
$form->setMax('adresse1',40 );
$form->setMax('adresse2',40 );
$form->setMax('cp',5 );
$form->setMax('ville',40 );
$form->setMax('telephone',15 );
$form->setMax('observation',4 );
$form->setMax('parente',15 );
}

function setSelect(&$form, $maj,$db,$debug) {
// dcd
$contenu=array();
$contenu[0]=array('Non','Oui');
$contenu[1]=array($this->lang('Non'),$this->lang('Oui'));
$form->setSelect("dcd",$contenu);
// civilite
$contenu=array();
$contenu[0]=array('Mr','Mme',"Melle");
$contenu[1]=array($this->lang("mr"),$this->lang("mme"),$this->lang("melle"));
$form->setSelect("titre",$contenu);
}

function setGroupe(&$form,$maj){
$form->setGroupe('adresse1','D');
$form->setGroupe('adresse2','F');

$form->setGroupe('cp','D');
$form->setGroupe('ville','F');
}

function setRegroupe(&$form,$maj){
$form->setRegroupe('adresse1','D',' '.$this->lang('adresse').' ');
$form->setRegroupe('adresse2','G','');
$form->setRegroupe('cp','G','');
$form->setRegroupe('ville','G','');
$form->setRegroupe('telephone','F','');

$form->setRegroupe('titre','D',' '.$this->lang('etat_civil').' ');
$form->setRegroupe('nom','G','');
$form->setRegroupe('prenom','G','');
$form->setRegroupe('marital','G','');
$form->setRegroupe('datenaissance','F','');
}


function setOnchange(&$form,$maj){
$form->setOnchange("nom","this.value=this.value.toUpperCase()");
$form->setOnchange("prenom","this.value=this.value.toUpperCase()");
$form->setOnchange("marital","this.value=this.value.toUpperCase()");
$form->setOnchange("adresse1","this.value=this.value.toUpperCase()");
$form->setOnchange("adresse2","this.value=this.value.toUpperCase()");
$form->setOnchange("ville","this.value=this.value.toUpperCase()");
$form->setOnchange("datenaissance","fdate(this)");
}

}// fin de classe
?>